package com.jenny.magic.networking.packets;

import com.jenny.magic.particles.effects;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.world.phys.Vec3;
import net.minecraftforge.network.NetworkEvent;

import javax.annotation.Nullable;
import java.util.function.Supplier;

public class EffectS2C {
    private final Effect effectID;
    private final Vec3 vector1, vector2;

    public EffectS2C(Effect effectID, @Nullable Vec3 origin, @Nullable Vec3 target) {
        this.effectID = effectID;
        this.vector1 = origin;
        this.vector2 = target;
    }

    public EffectS2C(FriendlyByteBuf buf) {
        this.effectID = Effect.values()[buf.getByte(2)];
        this.vector1 = new Vec3(buf.getFloat(3), buf.getFloat(7), buf.getFloat(11));
        this.vector2 = new Vec3(buf.getFloat(15), buf.getFloat(19), buf.getFloat(23));
    }

    public void toBytes(FriendlyByteBuf buf) {
        buf.writeByte(0);
        buf.writeByte(this.effectID.ordinal());
        buf.writeFloat((float) vector1.x);
        buf.writeFloat((float) vector1.y);
        buf.writeFloat((float) vector1.z);
        buf.writeFloat((float) vector2.x);
        buf.writeFloat((float) vector2.y);
        buf.writeFloat((float) vector2.z);
    }

    public boolean handle(Supplier<NetworkEvent.Context> supplier) {
        NetworkEvent.Context context = supplier.get();
        context.enqueueWork(() -> {
            System.out.println("test069 " + this.effectID + " " + this.vector1 + " " + this.vector2);
            effects.executeEffect(this.effectID, this.vector1, this.vector2);
        });
        return true;
    }

    public enum Effect {
        SCROLL_HEALTH,
        WAND_VACUUM
    }
}
