package com.jenny.magic.particles;

import com.jenny.magic.networking.packets.EffectS2C;
import net.minecraft.client.Minecraft;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.util.RandomSource;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.Vec3;

import javax.annotation.Nullable;

public class effects {
    public static void executeEffect(EffectS2C.Effect effect, @Nullable Vec3 origin, @Nullable Vec3 destination) {
        if (effect == EffectS2C.Effect.WAND_VACUUM) {
            wandVacuum(origin, destination);
        }
    }

    private static void scrollTeleport(Vec3 origin, Vec3 destination) {
    }

    private static void wandVacuum(Vec3 origin, Vec3 destination) {
        for (int i = 0; i < 20; i++) {
            Vec3 randPos = randPos2D(5);
            Vec3 pos = origin.add(randPos);
            Vec3 delta = randPos.scale(-0.1).add(0, 0.2, 0);
            level().addParticle(ParticleTypes.GLOW_SQUID_INK, pos.x, pos.y, pos.z, delta.x, delta.y, delta.z);
        }
    }

    public static Vec3 randPos(float maxDist) {
        return new Vec3(
                rng().nextFloat() * 2 - 1,
                rng().nextFloat() * 2 - 1,
                rng().nextFloat() * 2 - 1).normalize().scale(maxDist);
    }

    public static Vec3 randPos2D(float maxDist) {
        return new Vec3(
                rng().nextFloat() * 2 - 1,
                0,
                rng().nextFloat() * 2 - 1).normalize().scale(maxDist);
    }

    public static Vec3 randPosRandDist(float maxDist) {
        return new Vec3(
                rng().nextFloat() * 2 - 1,
                rng().nextFloat() * 2 - 1,
                rng().nextFloat() * 2 - 1).normalize().scale(rng().nextFloat() * maxDist);
    }

    private static Level level() {
        return Minecraft.getInstance().level;
    }

    private static RandomSource rng() {
        return level().getRandom();
    }
}
